///////////////////////////////////////////////////////////////////////////////
// 
// File:   serial.c
// Author: Koide Shigeki
// 
// Created on 2016/03/11
///////////////////////////////////////////////////////////////////////////////
//
// Ver 0.001 2016.03.12
// 
//
//-----------------------------------------------------------------------------
#include <p24FJ64GA002.h>
#include "GenericTypeDefs.h"
#include <stdio.h>
#include <string.h>
//#include "Define.h"
#include "Serial.h"

char rcv_data[200];     // Uart
//char srid[5];           // Ver 0.003
BYTE rcv_cnt = 0;       // Uart
BYTE rx_flg = 0;
//BYTE tx_flg = 0;

//BYTE flgCR = 0;

void U2init( void );
void putc2(char data);
//void puts2( char *data );
void puts2( char *data  );
BYTE getc_err2(void);
//int im920c_tx(BYTE dt);

///////////////////////////////////////////////////////////////////////////////
//
// Uart2̏ݒ
//
///////////////////////////////////////////////////////////////////////////////
void U2init( void )
{
    //-------------------------------------------
    // ^C}Q̏ݒ ONbN, 1/256, TCS = T1CK
    //-------------------------------------------
//    T2CON = 0x8030;
//    PR2 = 40000;                                 // 10s
//    TMR2 = 0;
    //-------------------------------------------
    // 荞݊֘Aݒ
    //-------------------------------------------
//    IPC1bits.T2IP = 5;  		// 荞݃x = 6
//    IFS0bits.T2IF = 0;
//  IEC0bits.T2IE = 1;                  // 荞݋

    //    IFS1bits.INT2IF = 0;
//    INTCON2bits.INT2EP = 1;                     // 茟o


//    U2BRG = 12;                         // 19200bps
////    U2BRG = 6;                         // 19200bps
//    U2MODE = 0x8008;
//    U2STA = 0x0400;
    IEC1bits.U2RXIE = 1;                // Uart2 RX݋
    IPC7bits.U2RXIP = 6;                // 荞݃x = 5

}

///////////////////////////////////////////////////////////////////////////////
//
// UART2M
// P
///////////////////////////////////////////////////////////////////////////////
void putc2( char data )
{
    U2STAbits.UTXEN = 1;
    U2TXREG = data;
    while( U2STAbits.UTXBF == 1 );
//    Delay_ms(20);
}

///////////////////////////////////////////////////////////////////////////////
//
// UART2M
// 
///////////////////////////////////////////////////////////////////////////////
void puts2( char *data )
{
//    char txdt[100];
//    strcpy( txdt, data );
//    BYTE n = 0;

//    U2STAbits.UTXEN = 1;    // Ver 0.201
//    for( n=0; n<len; n++ )
//    {
//        U2TXREG = txdt[n];
//        while( !U2STAbits.UTXBF == 0 );
//    }
//    rcv_cnt = 0;                        // Ver 0.201
//    IEC1bits.U2RXIE = 1;                // Uart2 RX$B3d9~$_5v2D(B

    while(1)
    {
        putc2(*data++);
        if( *data == '\0')
            break;
    }
    IEC1bits.U2RXIE = 1;                // Uart2 RX$B3d9~$_5v2D(B

}
///////////////////////////////////////////////////////////////////////////////
//
// MAI[o[G[At[~OG[Ή
//
///////////////////////////////////////////////////////////////////////////////
BYTE getc_err2(void)
{
    BYTE moji = 0;
//    while(!U2STAbits.URXDA);  // ͑҂
    /// MG[`FbN
    if(U2STAbits.OERR || U2STAbits.FERR)
    {
        U2STA &= 0xFFF0;   // G[tONA
        U2MODEbits.UARTEN = 0;  // UART2~
        U2MODEbits.UARTEN = 1;  // UART2L
    }
    else
    {
        moji = U2RXREG;   // f[^o
    }
    return moji;
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//void UART_putchar(BYTE dt)
//{
//    while (U2STA & 0x0200);
//    U2TXREG = dt;
//}


///////////////////////////////////////////////////////////////////////////////
// @@@
// tQM荞
//
///////////////////////////////////////////////////////////////////////////////
void __attribute__(( interrupt, auto_psv )) _U2RXInterrupt(void)
{
    BYTE    cmd = 0;
//    BYTE    n = 0;
//    BYTE    sn = 0;

//    SRbits.IPL = 0;
    // 荞݃tOXe[^XWX^
    // Mf[^𓾂
    while( 1 )
    {
        if( U2STAbits.URXDA == 0 )
        {
            IFS1bits.U2RXIF = 0;
            return;
        }
        cmd = getc_err2();
        if( cmd == 0 )
        {
            IFS1bits.U2RXIF = 0;
            return;
        }
        switch( cmd )
        {
            case  '\n':
                break;
            case  '\r':
                rcv_data[rcv_cnt] = '\0';
                rcv_cnt = 0;
                rx_flg = 1;
                break;
            default:
                rcv_data[rcv_cnt++] = cmd;
                break;
        }

    }
    IFS1bits.U2RXIF = 0;
}
